#include "Spots.h"

// MAIN INSTANTIATION FUNCTION
BArchivable *BlanketModule::Instantiate(BMessage* message)
{
	return new Spot(message);
}

SpotConfig::SpotConfig(BlanketModule *owner, BView* view)
 : BlanketModule::Config(owner, view, false)
{
	view->AddChild(new BStringView(BRect(10, 10, 200, 35), B_EMPTY_STRING, "Spots: a Blanket sample module"));
}

// Override Tick in my custom saver
SpotSaver::SpotSaver(BlanketModule *owner, BView* v)
 : DesktopSaver(owner, v, 10000)
{
	next = system_time() + 500000;
}

// This is where all the real work gets done to draw into the view
void SpotSaver::Tick()
{
	// If you don't call this you won't get the background!
	DesktopSaver::Tick();

	if(system_time() >= next)
	{
		// display spot
		BRect r;
		r.top = rand() % View()->Bounds().IntegerWidth();
		r.left = rand() % View()->Bounds().IntegerHeight();
		r.bottom = r.top + 30;
		r.right = r.left + 30;
		View()->FillRoundRect(r, 15, 15, B_SOLID_LOW);

		next = system_time() + 500000;
	}
}

Spot::Spot(BMessage* message)
 : BlanketModule(message)
{
}

BlanketModule::Saver* Spot::InstantiateSaver(BView *v, bool)
{
	return new SpotSaver(this, v);
}

BlanketModule::Config* Spot::InstantiateConfig(BView *v)
{
	return new SpotConfig(this, v);
}	
